/*
 * sommen.java
 * Joris van Rantwijk, Okt 1999
 * TU Delft
 */

import java.io.*;

public class sommen
{

	static final int MAXVAL = 1000000;
	static final int MAXLEN = 10;

	static StreamTokenizer fin;

	static int run;
	static int n;
	static int[] num;
	static char[] op;
	static int ans;

	static void leesSom() throws IOException
	{
		num = new int[MAXLEN];
		op = new char[MAXLEN-1];
		n = 0;
		do {
			fin.nextToken();
			num[n] = Integer.parseInt(fin.sval);
			fin.nextToken();
			if (! fin.sval.equals("="))
				op[n] = fin.sval.charAt(0);
			n++;
		} while (! fin.sval.equals("="));
		fin.nextToken();
		ans = Integer.parseInt(fin.sval);
	}

	public static boolean kijkSomNa(int[] num, char[] op, int n)
	{
		if (n == 1)
			return (num[0] == ans);

		int[] tnum = new int[n-1];
		char[] top = new char[n-2];

		for (int i = 0; i < n - 1; i++) {
			long r = -1;
			switch (op[i]) {
			  case '+': r = (long)num[i] + (long)num[i+1]; break;
			  case '-': r = (long)num[i] - (long)num[i+1]; break;
			  case '*': r = (long)num[i] * (long)num[i+1]; break;
			  case '/': r = (num[i+1] == 0 || 
			                 num[i] % num[i+1] != 0) ? -1 :
			                 (long)num[i] / (long)num[i+1]; break;
			}
			if (r >= 0 && r <= MAXVAL) {
				for (int j = 0; j < i; j++)
					tnum[j] = num[j];
				for (int j = 0; j < i; j++)
					top[j] = op[j];
				tnum[i] = (int) r;
				for (int j = i + 1; j < n - 1; j++)
					tnum[j] = num[j+1];
				for (int j = i; j < n - 2; j++)
					top[j] = op[j+1];
				if (kijkSomNa(tnum, top, n - 1))
					return true;
			}
		}

		return false;
	}

	public static void main(String[] args)
	{
		try {

			fin = new StreamTokenizer(
			        new FileInputStream("sommen.in"));
			fin.resetSyntax();
			fin.whitespaceChars(0, 0x20);
			fin.wordChars(0x21, 0xff);

			fin.nextToken();
			run = Integer.parseInt(fin.sval);

			while ((run--) > 0) {
				leesSom();
				if (kijkSomNa(num, op, n))
					System.out.println("goed");
				else
					System.out.println("fout");
			}

		} catch (IOException e) { }
	}

}

/* end */
