program tegelen (input, output);

const MAXSIDE = 99;
      INVOER  = 'tegelen.in';

type floorside = 1..MAXSIDE;
     floortype = array[floorside, floorside] of integer;
 
var  floor: floortype;

procedure clearfloor;
  var k, l: floorside;
  begin
    for k := 1 to MAXSIDE do
      for l := 1 to MAXSIDE do
         floor[k,l] := 0;
  end;

function minimaal(b, l: floorside): integer;
  var 
    u, v : floorside;

  procedure check(w: integer);
    begin
      if w < floor[b, l] then
        floor[b, l] := w;
    end;
 
  begin
    if floor[b, l] = 0 then
    begin
      floor[b, l] := b * l;
      for u := 1 to b - 1  do     
        check( minimaal(u, l) + minimaal(b - u, l) );
      for v := 1 to l - 1  do     
        check( minimaal(b, v) + minimaal(b, l - v) );
      floor[l, b] := floor[b, l];
    end; 
    minimaal := floor[b, l];
  end; 

procedure readtiles(var infile: text);
  var
    tegels, t: integer;
    lengte, breedte: floorside;
  begin
     readln(infile, tegels);
     for t := 1 to tegels do
     begin
       read(infile, breedte, lengte);
       floor[breedte, lengte] := 1;
       floor[lengte, breedte] := 1; 
     end;
     readln(infile);
  end;

procedure dofloors(var infile: text);
  var   
    lengte, breedte: floorside;
    floors, f: integer;
  begin
     readln(infile, floors);
     for f := 1 to floors do
     begin
       read(infile, breedte, lengte);
       write(minimaal(breedte, lengte), ' ');
     end;
     writeln;
     readln(infile);
  end;

procedure main;
  var 
    infile : text;
    aantal : integer; 
    caseno : integer;  
  begin
    assign(infile, INVOER);  
    reset(infile);
    readln(infile, aantal);
    for caseno := 1 to aantal do
    begin
      clearfloor;
      readtiles(infile);
      dofloors(infile);
    end;
    close(infile);
  end;

begin
  main
end.
